
import org.alice.apis.moveandturn.event.MouseButtonListener;
import org.alice.apis.moveandturn.event.MouseButtonEvent;
import org.alice.apis.moveandturn.*;
import org.alice.virtualmachine.ForEachRunnable;
import org.alice.virtualmachine.DoTogether;
import org.alice.virtualmachine.ForEachTogether;

public class MyScene extends Scene {

    private MySunLight sunLight = new MySunLight();
    private MyGrassyGround grassyGround = new MyGrassyGround();
    private MyCamera camera = new MyCamera();
    private MyBunny2 bunny2 = new MyBunny2();
    private MyCat cat = new MyCat();
    private MySphereHighPoly sphereHighPoly = new MySphereHighPoly();
    private MyTorus torus = new MyTorus();

    public MyScene() {
        this.performGeneratedSetUp();
        this.performMySetUp();
    }

    protected void performMySetUp() {
    }

    protected void performGeneratedSetUp() {
        this.setName("scene");
        this.setAtmosphereColor(new Color(0.5, 0.5, 1.0));
        this.sunLight.setName("sunLight");
        this.sunLight.setVehicle(this);
        this.sunLight.setLocalPointOfView(new PointOfView(new Quaternion(-0.7071067811865475, 0.0, 0.0, 0.7071067811865476), new Position(0.0, 0.0, 0.0)));
        this.grassyGround.setName("grassyGround");
        this.grassyGround.setVehicle(this);
        this.grassyGround.setLocalPointOfView(new PointOfView(new Quaternion(0.0, 0.0, 0.0, 1.0), new Position(0.0, 0.0, -0.0)));
        this.grassyGround.setColor(new Color(1.0, 1.0, 1.0));
        this.grassyGround.setOpacity(1.0);
        this.camera.setName("camera");
        this.camera.setVehicle(this);
        this.camera.setLocalPointOfView(new PointOfView(new Quaternion(-0.011126190497012304, -0.9870026595989109, -0.07858885344006476, 0.13973456961209216), new Position(-6.6130536129803E-30, 2.559999999999965, -16.0)));
        this.bunny2.setName("bunny2");
        this.bunny2.setVehicle(this);
        this.bunny2.setLocalPointOfView(new PointOfView(new Quaternion(0.0, 0.0, 0.0, 1.0), new Position(3.764238895936953, -1.3877787807814457E-17, -0.6644247317430043)));
        this.bunny2.setColor(new Color(1.0, 1.0, 1.0));
        this.bunny2.setOpacity(1.0);
        this.cat.setName("cat");
        this.cat.setVehicle(this);
        this.cat.setLocalPointOfView(new PointOfView(new Quaternion(0.0, 0.14017682426011746, 0.0, 0.9901264858291329), new Position(2.3789574013205783, 0.11135439993364851, -7.766623419052511)));
        this.cat.setColor(new Color(1.0, 1.0, 1.0));
        this.cat.setOpacity(1.0);
        this.sphereHighPoly.setName("sphereHighPoly");
        this.sphereHighPoly.setVehicle(this);
        this.sphereHighPoly.setLocalPointOfView(new PointOfView(new Quaternion(0.0, 0.14017682426011746, 0.0, 0.9901264858291329), new Position(-0.5619521699205703, 1.0, -6.298383795763849)));
        this.sphereHighPoly.setColor(new Color(1.0, 1.0, 1.0));
        this.sphereHighPoly.setOpacity(1.0);
        this.torus.setName("torus");
        this.torus.setVehicle(this);
        this.torus.setLocalPointOfView(new PointOfView(new Quaternion(0.0, 0.14017682426011746, 0.0, 0.9901264858291329), new Position(4.942589794794889, 0.04661739990115166, -7.951528690261737)));
        this.torus.setColor(new Color(1.0, 1.0, 1.0));
        this.torus.setOpacity(1.0);
    }

    public void click() {
         MyBunny2 b = new MyBunny2 ();
         b.setVehicle (this);
         b.moveTo (cat);
         
         MySphereHighPoly s = new MySphereHighPoly();
         s.setVehicle (bunny2);
         s.setOpacity(0.3);
    }
    
    public void run() {
        Window w = new Window ();
        w.setVisible (true);
        // w.test ();
        w.detail (this);
        
        this.bunny2.addMouseButtonListener(new MouseButtonListener() {
            public void mouseButtonClicked(final MouseButtonEvent e) {
                click ();
                MyScene.this.bunny2.say("hello");
            }
        });
        
        while (true) {
            this.bunny2.move(MoveDirection.FORWARD, 2.0);
            this.bunny2.turn(TurnDirection.RIGHT, 0.25);
        }
    }
}
