
import javax.swing.tree.*;
import org.alice.apis.moveandturn.*;
import java.lang.reflect.*;

public class Window extends javax.swing.JFrame {

    public Window() {
        initComponents();
    }
    
    DefaultTreeModel model;
    DefaultMutableTreeNode act;
 
    public void open (Object s)
    {
        DefaultMutableTreeNode node = new DefaultMutableTreeNode (s);
        if (model == null)
        {
            model = new DefaultTreeModel (node);
            jTree1.setModel (model);
        }
        else
        {
            int inx = act.getChildCount();
            model.insertNodeInto (node, act, inx);
        }
        act = node;
    }
 
    public void put (Object s)
    {
        DefaultMutableTreeNode node = new DefaultMutableTreeNode (s);
        int inx = act.getChildCount();
        model.insertNodeInto (node, act, inx);
    }
 
    public void close ()
    {
       act = (DefaultMutableTreeNode) act.getParent();
    }
 
    public void test ()
    {
        open ("Abc");
                put ("item 1");
                put ("item 2");
                open ("Klm");
                    put ("item 3");
                close ();
                put ("item 4");
        close ();
    }
    
    // import org.alice.apis.moveandturn.*;
    public void detail (Composite c)
    {
        open (c.getName());

        Transformable[] a = c.getComponents();
        for (Transformable t : a)
            if (t instanceof Composite)
               detail ((Composite) t);
            else
               put (t.toString ());
        
        Class cls = c.getClass ();
        open ("methods of " + cls.getName ());
        // import java.lang.reflect.*;
        Method [] met = cls.getMethods();
        for (Method m : met)
            put (m.getName());
        close ();
        
        close ();
    }

 

    
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jScrollPane1.setViewportView(jTree1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 322, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 278, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Window().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTree jTree1;
    // End of variables declaration//GEN-END:variables
}
